/* vi:set cindent tabstop=2: */
#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>

#include <sys/socket.h>
#include <netinet/in.h>

#include "mhihttp.h"

void do_http(int fd, struct sockaddr *addr)
{
		char req[0x100], *cmd, *url, *proto, *extension;
		char hdr[0x100];
		char location[0x100],filename[0x100];
		char host[0x100];
		int datafd;
		unsigned char *buf;
		int nread;
		int is_directory;

		is_directory = 0;

		sockgets(fd, req, sizeof(req) );
		cmd = req;
		url = cmd;
		while (*url != 0 && *url != ' ')
				url++;
		if (*url == 0) {
				sockputs(fd,"HTTP/1.0 400 Bad request");
				http_hdr(fd,"text/html");
				sockputs(fd,"I am sorry!");
				close(fd);
				exit(1);
		}
		*url++ = 0;
		proto = url;
		while (*proto != 0 && *proto != ' ')
				proto++;
		if (*proto != 0) {
			*proto++ = 0;
		}

		/* Read header */
		if (*proto) {
				while (1) {
					if (sockgets(fd, hdr, sizeof(hdr)) < 0)
							break;
					printf("[%s]\n",hdr);
					if (*hdr == 0)
							break;
					if (!strncasecmp(hdr,"Host:",5)) {
							strcpy(host,hdr+5);
					}
				}
		}

		compressstr(host);
		
		printf("[%s-%s(%s)-%s]\n",cmd,host,url,proto);
		switch (statfile(url,location,filename)) {
				case 0:
						/* Everyting is OK */
						break;
				case 1:
						/* Location: */
						sockputs(fd,"HTTP/1.0 301 Moved permanently");
						if (host)
								sockprintf(fd,"Location: http://%s%s\r\n",host,location);
						else sockprintf(fd,"Location: %s\r\n",location);
						http_hdr(fd,"text/html");
						sockputs(fd,"New location...");
						close(fd);
						exit(1);
				case 2:
						is_directory = 1;
						break;
				case -1:
						/* 404 not found */
						sockputs(fd,"HTTP/1.0 404 Lamer detected");
						http_hdr(fd,"text/html");
						sockputs(fd,"404 Lamer detected");
						close(fd);
						exit(1);
		}


		if (is_directory) {
				genindex(fd,filename);
				exit(0);
		}
		
		datafd = openfile(filename);
		if (datafd < 0) {
			sockputs(fd,"HTTP/1.0 500 MHI is lamer!!!");
			http_hdr(fd,"text/html");
			sockputs(fd,"500 Internal server error");
			close(fd);
			exit(1);
		}

		buf = (unsigned char*)malloc(10240);
		if (!buf) {
			sockputs(fd,"HTTP/1.0 500 No memory!");
			http_hdr(fd,"text/html");
			sockputs(fd,"500 Internal server error");
			close(fd);
			exit(1);
		}
		
		extension = getextension(url);
		if (!extension)
				exit(0);
		sockputs(fd,"HTTP/1.0 200 OK");
		http_hdr(fd,getmime(extension));
		free(extension);

		while ( (nread = read(datafd,buf,10240)) != 0) {
				write (fd, buf, nread);
		}


		close(datafd);
		close(fd);
		exit(0);
}

/*
 * Output standard header and terminate it.
 */
int http_hdr(int fd, char *content_type)
{
		if (sockputs(fd,"Server: mhihttp/0.0") <0)
				return -1;
		if (sockputs(fd,"Connection: close") < 0)
				return -1;
		if (sockprintf(fd,"Content-Type: %s\r\n",content_type) < 0)
				return 01;
		if (sockputs(fd,"") < 0)
				return -1;
		return 0;
}

/*
 * Returns:  0  == OK, file exists
             1  == Reloc, new location in `newlocation'
						 2  == Directory, generate directory content
						 -1 == 404 Not found.
 */
int statfile(char *url, char *newlocation, char *filename)
{
		struct stat statb;
		struct indexfile *index; 
		char temp[0x100];
		char *s;

		/* URL must begin with '/' */
		if (url[0]!='/')
				return -1;
		
		/* No /../ in URL ! */
		s = url;
		while (*s) {
				if (*s == '/' && strlen(s)>3 )
						if (!memcmp(s,"/../",4))
								return -1;
				s++;
		}

		strcpy(filename,docroot);
		strcat(filename,url);
		if (stat(filename,&statb) < 0)
				return -1;
		if (S_ISREG(statb.st_mode))
				return 0;
		/* We support only regular files and directories */
		if (!S_ISDIR(statb.st_mode))
				return -1;
		index = indexfiles;
		while (index) {
				strcpy(temp, filename);
				strcat(temp, "/");
				strcat(temp, index->name);
				if (stat(temp,&statb) == 0) {
						strcpy(newlocation, url);
						strcat(newlocation, "/");
						strcat(newlocation, index->name);
						return 1;
				}
				index = index->next;
		}
		if (url[strlen(url)-1] == '/')
				return 2;
		strcpy(newlocation, url);
		strcat(newlocation, "/");
		return 1;
}

int openfile(char *filename)
{
		int fd, nfd;

		fd = open(filename, O_RDONLY);
		if (fd == -1)
				return -1;

		nfd = uncompress(fd);
		if (nfd != -1)
				return nfd;
		
		return fd;
}
