/* vi:set cindent tabstop=2: */
#ifndef __MHIHTTP_H
#define __MHIHTTP_H

#include <netinet/in.h>

#include "conf.h"

struct indexfile {
		char *name;
		struct indexfile *next;
};

struct mimetype {
		char *extension;
		char *type;
		struct mimetype *next;
};

struct indexfile *indexfiles;
struct mimetype *mimetypes;
char docroot[];
char defaultmime[];
int verbose;

/* main.c */
extern void add_indexfile(char *name);

/* http.c */
extern void do_http(int fd, struct sockaddr *addr);
extern int http_hdr(int fd, char *content_type);
extern int statfile(char *url, char *newlocation, char *filename);

/* socket.c */
extern int sockgets(int socket, char *buf, int len);
extern int sockputs(int socket, char *buf);
extern int sockprintf (int socket, char * format, ...);

/* util.c */
extern char * compressstr(char *s);
extern int mkpipe(char *command,char *args,int fd);
extern int removezombies();
extern char *escapestr(char *dest, char *src);
extern char *getextension(char *);

/* uncomp.c */
extern int uncompress(int fd);

/* indexdir.c */
extern int genindex(int fd,char *directory);

/* mime.c */
extern char *getmime(char *extension);
extern int *addmime(char *type, char *extension);
extern int read_mimetypes(char *filename);

#endif
