/* vi: set cindent tabstop=2: */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "mhihttp.h"

char *getmime(char *extension)
{
		struct mimetype *types;

		types = mimetypes;
		while (types) {
				if (!strcmp(types->extension, extension))
						return types->type;
				types = types->next;
		}
		return defaultmime;
}

int *addmime(char *type, char *extension)
{
		struct mimetype *mime;

		mime = (struct mimetype *)malloc(sizeof(struct mimetype));
		if (!mime)
				return -1;
		mime->type = strdup(type);
		if (!mime->type) {
				free(mime);
				return -1;
		}
		mime->extension = strdup(extension);
		if (!mime->extension) {
				free(mime->type);
				free(mime);
				return -1;
		}

		mime->next = mimetypes;
		mimetypes = mime;

		return 0;
}

int read_mimetypes(char *filename)
{
		FILE *f;
		char line[0x100];
		char *ext,*s;

		f = fopen(filename, "rt");
		if (!f)
				return -1;
		while (fgets(line,0x100,f)) {
				if (line[0] == 0)
						continue;
				if (line[strlen(line)-1] == '\n')
						line[strlen(line)-1] = 0;
				s = line;
				while (*s != ' '&& *s != '\t' && *s)
						s++;
				if (!*s)
						continue;
				*s++ = 0;
				while (*s == ' ' || *s == '\t')
						s++;
				if (!*s)
						continue;
				while (*s) {
						ext = s;
						while (*s != ' ' && *s != '\t' && *s)
								s++;
						if (!*s)
						{
								addmime(line,ext);
								break;
						}
						*s++ = 0;
						addmime(line,ext);
						while (*s == ' ' || *s == '\t')
								s++;
				}
		}
		fclose(f);
		return 0;
}
