/* vi:set cindent tabstop=2: */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "mhihttp.h"

char *compressstr(char *s)
{
		char *ns;

		ns = s;
		while (*ns == ' ' || *ns == '\t')
			ns++;
		while (*ns)
				*s++ = *ns++;
		*s = 0;
		return s;
}

int mkpipe(char *command,char *args,int fd)
{
  char *argv[4];
	int fds[2];
	char cmdline[0x100];
	FILE *f;

	pipe(fds);
	if (fork()==0) {
			close(fds[0]);
			close(0);
			close(1);
			
			dup2(fd, 0);
			dup2(fds[1],1);

			close(fd);
			close(fds[1]);
			argv[0] = command;
			argv[1] = args;
			argv[2] = 0;
			execv(command, argv);
			_exit(127);
	}
	close(fds[1]);
	close(fd);
	return fds[0];
}

int removezombies()
{
	int status;
	pid_t pid;

	while ((pid = waitpid(-1, &status, WNOHANG)) > 0)
			;
}

/*
 * escapestr: Copyright (C) 1997 Jon Nelson <nels0988@tc.umn.edu>
 *
 *  This function is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 1, or (at your option)
 *  any later version.
 */

unsigned long _needs_escape[8] = {
	0xffffffff, 0x780000fd, 0x78000001, 0xb8000001,
	0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff
};

#define needs_escape(c) (_needs_escape[(c)>>5]&(1<<((c)&0x1f)))

#define HEXDIGIT(x) ((((x)-10)>=0)?('A'+((x)-10)):('0'+(x)))

char *escapestr(char *dest, char *src)
{
	int max;
	char *index;
	unsigned char c;

	max = strlen(src) * 3;

	index = dest;
	while ((c = *src++)) {
		if (needs_escape((unsigned int) c)) {
			*index++ = '%';
			*index++ = HEXDIGIT(c >> 4);
			*index++ = HEXDIGIT(c & 15);
		} else
			*index++ = c;
	}
	*index = '\0';

	return dest;
}

char *getextension(char *filename)
{
		char *dot, *pdot;
		char *ext;
		int len;

		dot = 0;
		pdot = 0;
		len = 0;
		while (*filename) {
				if (*filename == '.') {
						pdot = dot;
						dot = filename;
#ifdef GUNZIP
						if (!strcmp(dot, ".gz") || !strcmp(dot, ".Z") ||
										!strcmp(dot, ".z") || !strcmp(dot, ".bz2") ) {
								len = dot-pdot-1;
								dot = pdot;
								break;
						}
#endif /* GUNZIP */
					}
				filename ++;
		}

		if (dot && len==0) {
			len = strlen(dot+1);
		}
		ext = (char *)malloc(len+1);
		memcpy(ext,dot+1,len);
		ext[len] = 0;
		return ext;
}

